10  M$="*******************************************************************************"
20  CLS
30  PRINT M$
40  PRINT
50  PRINT "                          1% RESISTOR FINDING PROGRAM "
60  PRINT:PRINT M$
70  PRINT
80  PRINT "                   This program will find the two closest values of"
90  PRINT "                the 96 standard 1% resistor decade, to generate a"
100  PRINT "                specified ratio between two resistors Rin and Rf."
110  PRINT "                   You will be asked for the ratio that you want."
120  PRINT "                The ratio that you want should be algebraically "
130  PRINT "                positive."
140  PRINT "                   During the course of computation the two closest"
150  PRINT "                values of Rin and Rf will be continuously displayed"
160  PRINT "                as well as the closest ratio found up to that time."
170  PRINT "                   In an Op-amp circuit Rin is the input resistor" 
180  PRINT "                and Rf is the feed-back resistor."
190  PRINT:PRINT
200  INPUT "                Type <RETURN> to continue....";BG$
210  CLS
220  DIM SCRATCH(96)
230  DIM DENOM(96)
240  DIM NEUM(96)
250  INPUT "               Please type the desired gain ratio  ";GAIN
260  IF GAIN<=0 THEN 810
270  DENOMXMULT=1
280  NEUMXMULT=1
290  RIN=0
300  RF=0
310  MISTAKE#=10000
320  IF GAIN>9.760002 THEN NEUMXMULT=10
330  IF GAIN<.102459 THEN DENOMXMULT=10
340  IF GAIN>97.60002 THEN NEUMXMULT=100
350  IF GAIN<.0102459 THEN DENOMXMULT=100
360  IF GAIN>976.0002 THEN NEUMXMULT=1000
370  IF GAIN<1.02459E-03 THEN DENOMXMULT=1000
380  FOR I=1 TO 96
390  READ SCRATCH(I)
400  DENOM(I)=DENOMXMULT*SCRATCH(I)
410  NEUM(I)=NEUMXMULT*SCRATCH(I)
420  NEXT I
430  FOR J=1 TO 96
440  PRINT J
450  FOR K=1 TO 96
460  DERIVE=NEUM(J)/DENOM(K)
470  NEWXMISTAKE#=ABS(GAIN-DERIVE)
480  IF NEWXMISTAKE#>MISTAKE# THEN 520
490  MISTAKE#=NEWXMISTAKE#
500  RIN=DENOM(K)
510  RF=NEUM(J)
520  NEXT K
530  NEXT J
540  CLS
550  FOR J=1 TO 5
560  PRINT
570  NEXT J
580  PRINT "                 The desired Rin/Rf ratio was: ";GAIN
590  PRINT "                 The best that can be done with"
600  PRINT "                 the standard 96 1% resistor values"
610  PRINT "                 are:"
620  PRINT
630  PRINT "                 Rf=   ";RF" ohms"
640 PRINT "                 Rin=   ";RIN" ohms"
650 PRINT "                 The ratio of Rf/Rin = ";RF/RIN
660 PRINT
670 PRINT "                 Error is ";100*(ABS(((RF/RIN)-GAIN)/GAIN));"%"
680 PRINT
690 PRINT "                 Calculations complete"
700 PRINT CHR$(7);:FOR T=1 TO 1000:NEXT:GOTO 700
710 END
720 DATA 1.00,1.02,1.05,1.07,1.10,1.13,1.15,1.18,1.21,1.24
730 DATA 1.27,1.30,1.33,1.37,1.40,1.43,1.47,1.50,1.54,1.58
740 DATA 1.62,1.65,1.69,1.74,1.78,1.82,1.87,1.91,1.96,2.00
750 DATA 2.05,2.10,2.15,2.21,2.26,2.32,2.37,2.43,2.49,2.55
760 DATA 2.61,2.67,2.74,2.80,2.87,2.94,3.01,3.09,3.16,3.24,3.32
770 DATA 3.40,3.48,3.57,3.65,3.74,3.83,3.92,4.02,4.12,4.22,4.32,4.42
780 DATA 4.53,4.64,4.75,4.87,4.99,5.11,5.23,5.36,5.49,5.62,5.76,5.90
790 DATA 6.04,6.19,6.34,6.49,6.65,6.81,6.98,7.15,7.32,7.50,7.68,7.87
800 DATA 8.06,8.25,8.45,8.66,8.87,9.09,9.31,9.53,9.76
810 PRINT:PRINT"Ratio must be positive "
820 PRINT "                Please re-input:":PRINT:GOTO 250
